"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = __importDefault(require("react"));
var functions_1 = require("../utils/functions");
var constants_1 = require("../utils/constants");
function ScrollAnimationItem(_a) {
    var children = _a.children, _b = _a.delay, delay = _b === void 0 ? 0 : _b, _c = _a.duration, duration = _c === void 0 ? 1200 : _c, className = _a.className, _d = _a.offset, offset = _d === void 0 ? { x: 0, y: 0, z: 0 } : _d, _e = _a.threshold, threshold = _e === void 0 ? 0.7 : _e, _f = _a.reAnimate, reAnimate = _f === void 0 ? false : _f, rest = __rest(_a, ["children", "delay", "duration", "className", "offset", "threshold", "reAnimate"]);
    var _g = react_1.default.useState(false), showed = _g[0], setShowed = _g[1];
    var _h = react_1.default.useState({
        y: 1,
        ratio: -1,
    }), previous = _h[0], setPrevious = _h[1];
    var ref = react_1.default.useRef(null);
    var style = useStyles(offset);
    var newClassName = "" + (className || constants_1.basicClassName);
    var handleScroll = react_1.default.useCallback(function (_a) {
        var entry = _a[0];
        var element = ref.current;
        var currentY = entry.boundingClientRect.y;
        var currentRatio = entry.intersectionRatio;
        var isIntersecting = entry.isIntersecting;
        // Scrolling down/up
        if (currentY < previous.y) {
            if (currentRatio > previous.ratio && isIntersecting && !showed) {
                functions_1.setShowObserveAnimation(element, duration, delay);
                setTimeout(function () {
                    setShowed(true);
                }, duration / 2);
            }
        }
        else if (currentY > previous.y && !isIntersecting && showed && reAnimate) {
            if (currentRatio < previous.ratio) {
                functions_1.setHideObserveAnimation(element, duration, delay, offset);
                setTimeout(function () {
                    setShowed(false);
                }, duration / 2);
            }
        }
        if (!showed || (showed && reAnimate)) {
            if (previous.y != currentY && previous.ratio != currentRatio) {
                setPrevious({
                    y: currentY,
                    ratio: currentRatio,
                });
            }
        }
    }, [previous, showed]);
    react_1.default.useEffect(function () {
        var current = ref.current;
        if (current) {
            var observer_1 = new IntersectionObserver(handleScroll, { threshold: threshold });
            observer_1.observe(current);
            return function () { return observer_1 && observer_1.disconnect(); };
        }
        return;
    }, [handleScroll]);
    return (jsx_runtime_1.jsx("div", __assign({ className: newClassName, style: style, ref: ref }, rest, { children: children }), void 0));
}
exports.default = ScrollAnimationItem;
function useStyles(_a) {
    var _b = _a.x, x = _b === void 0 ? 0 : _b, _c = _a.y, y = _c === void 0 ? 0 : _c, _d = _a.z, z = _d === void 0 ? 0 : _d;
    return {
        opacity: 0,
        overflow: 'hidden',
        transform: "translate3d(" + -x + "px, " + -y + "px, " + -z + "px)",
    };
}
//# sourceMappingURL=ObserveAnimation.js.map